/*
// A simple procedural implementation of some numerical
// integration rules.
//
*/

#include <stdio.h>

typedef double valueType ;
typedef int    indexType ;

typedef valueType (*functionType) ( valueType x ) ;

// declaration of the prototype of the trapezoidal integration rule
valueType
trap( functionType fun,  // pointer to the function to integrate
      valueType    a,    // left boundary
      valueType    b,    // right boundary 
      indexType    N ) ; // number of interval

// declaration of the prototype of the midpoint integration rule
valueType
midpoint( functionType fun,  // pointer to the function to integrate
          valueType    a,    // left boundary
          valueType    b,    // right boundary 
          indexType    N ) ; // number of interval

// declaration of the prototype of the Simpson integration rule
valueType
simpson( functionType fun,  // pointer to the function to integrate
         valueType    a,    // left boundary
         valueType    b,    // right boundary 
         indexType    N ) ; // number of interval
      
