/*
// A simple procedural implementation of some numerical
// integration rules.
//
*/

#include "intrule.h"
#include <math.h>

static
valueType
testFun( valueType x ) {
  return x*exp(-x) ;
}

int
main() {
  
  valueType a = 0  ;
  valueType b = 10 ;

  for ( indexType N = 10 ; N <= 1000 ; N *= 2 ) {
  
    valueType t = trap     ( testFun, a, b, N ) ; // call trapeziodal integrator
    valueType m = midpoint ( testFun, a, b, N ) ; // call midpoint integrator
    valueType s = simpson  ( testFun, a, b, N ) ; // call Simpson integrator
    
    // print the result
    printf( "Integration with %d intervals\n", N);
    printf( "Trapezoidal rule %10lf\n", t);
    printf( "Midpoint rule    %10lf\n", m);
    printf( "Simspon rule     %10lf\n", s);
  }
  printf( "All done!\n");
  return 0;
}
